<?php
namespace App\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Response;
use App\Utils\Utils;

class CheckController extends Controller
{
    private $utils;

    public function __construct(Utils $utils) {
        $this->utils = $utils;
    }

    public function checkAction($type)
    {
        $response = new Response();
        $response->setStatusCode(200);
        switch ($type) {
            case "online":
                return $response;
            break;
            case "mgmt":
                $response->setStatusCode($this->_checkMgmtAction());
                return $response;
            case "webssh":
                $response->setStatusCode($this->_checkWebSshAction());
                return $response;
            break;
            case "sysupdate":
                $response->setStatusCode($this->_checkUpdateRunning('_sys-update-running'));
                return $response;
            break;
            case "sys":
                $response->setStatusCode($this->_checkUpdateRunning('_sys-update-running'));
                return $response;
            break;
            case "osupdate":
                $response->setStatusCode($this->_checkUpdateRunning('_os-update-running'));
                return $response;
            break;
            case "uiupdate":
                $response->setStatusCode($this->_checkUpdateRunning('_ui-update-running'));
                return $response;
            break;
            default:
                return $response;
            break;
        }
    }

    private function _checkMgmtAction()
    {
        $result = $this->utils->checkManagementRunning(false);
        if (!$result) {
            // not running or currently executing a command
            return 500;
        } else {
            // running and doing nothing
            return 200;
        }
    }

    private function _checkWebSshAction()
    {
        $result = $this->utils->checkWebSshRunning(false);
        if (!$result) {
            // not running or currently executing a command
            return 500;
        } else {
            // running and doing nothing
            return 200;
        }
    }

    private function _checkUpdateRunning($type)
    {
        $result = $this->utils->checkUpdateRunning($type);
        if ($result === true) { return 200; }
        $this->utils->setOled();
        return 500;
    }
}