<?php
Namespace App\Model\Admin;

Use App\Utils\Utils;

/**
 * Provides admin functions for Homegear CA management
 *
 */
class HomegearCa
{
    public $hg;
    private $utils;

    public function __construct(Utils $utils)
    {
        $this->hg = new \Homegear\Homegear;
        $this->utils = $utils;
    }

    public function exists()
    {
        if ($this->utils->checkManagementRunning(false)) {
            return $this->hg->managementCaExists();
        }
        return -1;
    }

    public function create()
    {
        if ($this->utils->checkManagementRunning(false)) {
            $id = $this->hg->managementCreateCa();
            $result = $this->utils->getCommandStatus($id);
            if ($result['exitCode'] == 0) {
                // CA created successfully, let's create the certificate for the gateways
                $id = $this->hg->managementCreateCert("gateway-client");
                $result = $this->utils->getCommandStatus($id);
                // create the server certificate for the rpcservers
                $id = $this->hg->managementCreateCert("rpcserver");
                $result = $this->utils->getCommandStatus($id);
                // update the config
                $this->hg->managementSetConfigurationEntry('rpcservers.conf','certPath','/etc/homegear/ca/certs/rpcserver.crt');
                $this->hg->managementSetConfigurationEntry('rpcservers.conf','keyPath','/etc/homegear/ca/private/rpcserver.key');
                return ['status' => 'success'];
            }
            return ['status' => 'error'];
        }
        return ['status' => 'error'];
    }
}