<?php
Namespace App\Model;

/**
 * Provides base functions for Homegear profiles
 *
 */
class HomegearProfile
{
    public $hg;
    public $defaultLanguage;

    public function __construct($params)
    {
        $this->hg = new \Homegear\Homegear;
        $this->defaultLanguage = $params->get('default_locale');
    }

    /**
     * Load all profiles
     * 
     * @return array()
     */
    public function loadAll()
    {
        try {
            $allProfiles = $this->hg->getAllVariableProfiles();
            return (count($allProfiles) > 0 ? $allProfiles : null);
        } catch(\Homegear\HomegearException $e) {
            return null;
        }
    }

}